/*
name: myaudio.h
info: interface to the audio device for setting volume and so on
author: Dusan Halicky (dvh.tosomja@post.sk)
licence: GNU GPL
history: 2005-09-22 - start of developement, based on mix v1.0 (Bjorn Ahlquist <a97bjoah@ida.his.se>), mixer init and get volume of specified channel
todo: - finish and release this
bugs: - 
*/

#ifndef MYAUDIO
#define MYAUDIO

#include <linux/soundcard.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>


int mfd;			// mixer file descriptor
int mixsup;			// ???
unsigned char level[2];		// auxiliary variable for ioctl, must be global else it makes segmentation fault on get volume, i don't know why

int
myaudio_mixer_init (void)
{
  // open /dev/mixer
  if ((mfd = open ("/dev/mixer", O_RDWR, 0)) < 0)
    {
      perror ("myaudio: unable to open /dev/mixer\n");
      exit (-1);
    } 
  else
    printf ("myaudio: mixer /dev/mixer opened successfully (mfd=%d)\n",mfd);
  // get list of mixer devices (master,pcm,headphone,..???)
  if (ioctl (mfd, SOUND_MIXER_READ_DEVMASK, &mixsup))
    {
      perror ("myaudio: unable to get list of mixer devices\n");
      exit (-1);
    }
  else
    printf ("myaudio: get list of mixer's devices successfull (mixsup=%d)\n",mixsup);
  return 0;
}

void
myaudio_mixer_get_volume(int id, unsigned char *volume_left, unsigned char *volume_right)
{
  // this get the volume of selected "channel" in the mixer (i.e. SOUND_MIXER_VOLUME for master volume, SOUND_MASTER_PCM for playback, ...)
  ioctl(mfd,MIXER_READ(id),&level);
  *volume_left=level[0];
  *volume_right=level[1];
}

void
myaudio_mixer_set_volume(int id, unsigned char volume_left, unsigned char volume_right)
{
  // this set volume of selected "channel" in the mixer (i.e. SOUND_MIXER_VOLUME for master volume, SOUND_MASTER_PCM for playback, ...)
//  unsigned char level[2];		// volume level (2 chanels, left first, right last, 0-255, together 0-65535)
  level[0]=volume_left;
  level[1]=volume_right; 
  ioctl(mfd,MIXER_WRITE(id),&level);
}

#endif // MYAUDIO
